#include "StdAfx.h"
#include "WASUpdateGroupSortOrder.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"

CWASUpdateGroupSortOrder::CWASUpdateGroupSortOrder(CWASActor *pActor) : 
CWASCommand(pActor)
{
    m_nGroupID = 0;
    m_nSortOrder = 0;
}

CWASUpdateGroupSortOrder::~CWASUpdateGroupSortOrder(void)
{

}

void CWASUpdateGroupSortOrder::ExecuteAsync()
{
	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}

	USES_UTF8_CONVERSION;

	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/buddy/SetGroupSortOrder.php");

	m_httpFacade.session().SetURL(W2U8(strURL.c_str()),	pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);

	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));

	wstring strgrpids;
	wstring strsortorders;
	
	vector<GT_BUDDY_GROUP_DATA>::const_iterator itr = m_vecGroupData.begin();
	for (; itr != m_vecGroupData.end(); itr++ )
	{
		if (strgrpids.empty() != true)
			strgrpids += _T(",");
		if (strsortorders.empty() != true)
			strsortorders += _T(",");

		GT_BUDDY_GROUP_DATA groupdata;
		groupdata = *itr;
		WCHAR bufgrpids[256];
		wsprintf(bufgrpids, L"%d",groupdata.nID);
		strgrpids += bufgrpids;
		
		WCHAR bufsortorders[256];
		wsprintf(bufsortorders, L"%d",groupdata.nSortOrder);
		strsortorders += bufsortorders;
	}

	m_httpFacade.session().AddBodyVariable("grpids", W2U8(strgrpids.c_str()));
	m_httpFacade.session().AddBodyVariable("sortorders", W2U8(strsortorders.c_str()));

	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);
}

bool CWASUpdateGroupSortOrder::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	//m_vecGroupData.clear();

	// TODO: XML Parsing


	return true;
}


// override in drived class
void CWASUpdateGroupSortOrder::OnWasResponse(trid_t trid,
									bool bSuccess,
									int /*nWinINetErrorCode*/, 
									int /*nHttpResponseCode*/, 
									LPCSTR /*szWasResCodeInHeader*/, 
									LPCSTR szWasResCodeInXml,
									nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		OutputDebugString(_T("\r\n##### CWASUpdateGroup::OnWasResponse:true #####\r\n"));
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}
	//else
	//{
	//	if(StringUtil::StrCompareA(szWasResCodeInXml, "205") == 0)
	//		m_eError = wasError_DuplicateGroupName;
	//}

	GT_ASSERT(m_pActor);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
	m_pActor->GetObserversEx(&observers);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();

	//GT_BUDDY_GROUP_UPDATABLE_DATA sData;
	//m_sGroupInfo.Convert(sData);

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
		if(pObserver->OnGTWASActor_ResponseUpdateGroupSortOrder(m_pActor, GetID(), m_eError, m_vecGroupData) == false)
			break;
	}

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());

}


void CWASUpdateGroupSortOrder::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
	m_pActor->GetObserversEx(&observers);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();

	GT_BUDDY_GROUP_UPDATABLE_DATA sData;
	m_sGroupInfo.Convert(sData);

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
		if(pObserver->OnGTWASActor_ResponseUpdateGroupSortOrder(m_pActor, GetID(), m_eError, m_vecGroupData) == false)
			break;
	}

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
